%% $Id: mixerAPI.tex,v 1.1 2001/04/02 20:37:00 Philip.Charlton Exp $

%% Start of test MIXERAPI01
\pagebreak
\renewcommand{\arraystretch}{1.5}       
\noindent
\begin{tabular}{@{}p{10em}@{}p{24em}@{}}
{\bf Test Case:}        & MIXERAPI01 \\
{\bf Purpose: }         & To test that {\tt std::domain\_error} and
                          {\tt std::invalid\_argument} errors thrown by
                          the mixer class (corresponding to out-of-range 
                          frequency and zero-length input sequence) are 
                          caught and recorded at the Tcl layer.\\
{\bf Tester: }          & \rule{15em}{.1pt} \\
{\bf Test machine: }    & \rule{15em}{.1pt} \\
{\bf Date (mm/dd/yy): } & \rule{2em}{.1pt}/\rule{2em}{.1pt}/\rule{2em}{.1pt}
\hspace{2em} {\bf Time: } \rule{6em}{.1pt}\\
\end{tabular}
\renewcommand{\arraystretch}{1} 
\vspace{1em}

\noindent   
{\bf NOTE:} 
This test should be performed for real float (R4), real double (R8), 
complex float (C8), and complex double (C16) data types.
\vspace{1em}
            
\noindent
{\bf ENVIRONMENT AND PREREQUISITES}
\vspace{1em}
            
\noindent   
The following input data sets are required for this test:
\begin{enumerate}
\item N200XX.sim
\end{enumerate} 
where XX is either R4, R8, C8, or C16.
\vspace{1em} 

\noindent   
{\bf PROCEDURE}
\begin{enumerate}
             
\item Indicate which data type is currently being tested.\\
\hspace*{\fill} {\bf R4/ R8/ C8/ C16}
             
\item ({\tt domain\_error} in constructor) Issue ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol file:/mdc/input/N200XX.sim
    -inputformat ilwd 
    -returnprotocol file:/mdc/output/MIXERAPI01AXX.ilwd
    -returnformat ilwd 
    -resultname {None}
    -resultcomment {None}
    -aliases {raw=chan_01:data}
    -algorithms {
      x = slice(raw,0,100,1);
      phi = value(0.0);
      f = value(2.0);
      z = mix(phi,f,x);
    }    
}        
\end{verbatim}
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that a {\tt std::domain\_error}, indicating an 
out-of-range frequency, appears in the appropriate log file.\\ 
\hspace*{\fill} {\bf Pass / Fail}

\item ({\tt invalid\_argument} in apply method) Issue ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol file:/mdc/input/N200XX.sim
    -inputformat ilwd 
    -returnprotocol file:/mdc/output/MIXERAPI01BXX.ilwd
    -returnformat ilwd 
    -resultname {None}
    -resultcomment {None}
    -aliases {raw=chan_01:data}
    -algorithms {
      x = slice(raw,0,0,1);
      phi = value(0.0);
      f = value(0.125);
      z = mix(phi,f,x);
    }    
}        
\end{verbatim}
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that a {\tt std:invalid\_argument} error, 
indicating a zero-length input sequence, appears in the appropriate 
log file.\\ 
\hspace*{\fill} {\bf Pass / Fail}

\end{enumerate}

\noindent
{\bf SUMMARY}
\vspace{1em}
             
\noindent    
{\bf Known faults encountered -- list bug IDs: }\hrulefill\\
\vspace{1em} 
\hrule       
\vspace{1em} 
\noindent    
{\bf New faults submitted -- list bug IDs: }\hrulefill \\
\vspace{1em} 
\hrule       
\vspace{2em} 
             
\noindent
{\bf TEST RESULT } \hfill {\bf Pass / Fail }\\
%% End of test MIXERAPI01

%% Start of test MIXERAPI02
\pagebreak
\renewcommand{\arraystretch}{1.5}       
\noindent
\begin{tabular}{@{}p{10em}@{}p{24em}@{}}
{\bf Test Case:}        & MIXERAPI02 \\
{\bf Purpose: }         & To verify that the mixer action returns correct 
                          values when acting on unbroken and broken input 
                          sequences.\\
{\bf Tester: }          & \rule{15em}{.1pt} \\
{\bf Test machine: }    & \rule{15em}{.1pt} \\
{\bf Date (mm/dd/yy): } & \rule{2em}{.1pt}/\rule{2em}{.1pt}/\rule{2em}{.1pt}
\hspace{2em} {\bf Time: } \rule{6em}{.1pt}\\
\end{tabular}
\renewcommand{\arraystretch}{1} 
\vspace{1em}

\noindent    
{\bf NOTE:}  
This test should be performed for real float (R4), real double (R8), 
complex float (C8), and complex double (C16) data types.
\vspace{1em} 
             
\noindent
{\bf ENVIRONMENT AND PREREQUISITES}
\vspace{1em} 
             
\noindent    
The following data sets are required for this test:
             
\begin{enumerate}
             
\item Input data:
             
\begin{enumerate}
             
\item N200XX.sim
             
\end{enumerate} 
             
where XX is either R4, R8, C8, or C16.
These data sets consist of sequences of random numbers.
             
\item Expected results:
             
\begin{enumerate}
\item MIXERAPI02AXX.exp
\end{enumerate}
             
where XX is R4, R8, C8, or C16.
These data sets contain the expected results for the mixer
action on unbroken sequences of length $N=100$.
             
\end{enumerate}
\vspace{1em} 
             
\noindent    
{\bf PROCEDURE}
\begin{enumerate}
             
\item Indicate which data type is currently being tested.\\
\hspace*{\fill} {\bf R4/ R8/ C8/ C16}
             
\item (unbroken sequence) Issue the following ldas command          
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol { 
      file:/mdc/input/N200XX.sim
      file:/mdc/input/MIXERAPI02AXX.exp 
    }        
    -inputformat ilwd 
    -returnprotocol file:/MIXERAPI02AXX.ilwd
    -returnformat ilwd 
    -resultname {mix}
    -resultcomment {Mixer result} 
    -aliases {raw=chan_01:data; exp=mixout:data }
    -algorithms { 
      x = slice(raw, 0, 100, 1);
      f = value(0.125);
      phi = value(0.1);
             
      rx = real(x);
      ix = imag(x);
      variance(rx);
      intermediate(,,rvarX, {Variance of real input data});
      rms(rx);
      intermediate(,,rrmsX, {RootMeanSquare of real input data});
      variance(ix);
      intermediate(,,ivarX, {Variance of imag input data});
      rms(ix);
      intermediate(,,irmsX, {RootMeanSquare of imag input data});
             
      z = mix(phi, f, x);
             
      rz = real(z);
      rexp = real(exp);
      rdif = sub(rz,rexp);
      min(rdif);
      intermediate(,,rminD,{Minimum real deviation});
      max(rdif);
      intermediate(,,rmaxD,{Maximum real deviation});
      variance(rdif);
      intermediate(,,rvarD,{Variance of real deviation});
      rms(rexp);
      intermediate(,,rrmsE,{RootMeanSquare of real expected result});
             
      iz = imag(z);
      iexp = imag(exp);
      idif = sub(iz,iexp);
      min(idif);
      intermediate(,,iminD,{Minimum imag deviation});
      max(idif);
      intermediate(,,imaxD,{Maximum imag deviation});
      variance(idif);
      intermediate(,,ivarD,{Variance of imag deviation});
      rms(iexp);
      intermediate(,,irmsE,{RootMeanSquare of imag expected result});
             
      value(z);
   } 
}    
\end{verbatim}
\hspace*{\fill} {\bf Pass / Fail}
             
\item Verify that the minimimum and maximum values of the real and 
imaginary parts of the differences between the calculated and expected
results are zero to floating point (or double) precision, 
relative to the rms amplitude of the expected results.\\
\hspace*{\fill} {\bf Pass / Fail}
\item Move the output file to {\tt mdc/output/api}.\\
\hspace*{\fill} {\bf Pass / Fail}
             
\item (broken sequence) Issue the following ldas command          
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol file:/mdc/input/N200XX.sim
    -inputformat ilwd 
    -returnprotocol file:/MIXERAPI02BXX.ilwd
    -returnformat ilwd 
    -resultname {mixerbroken}
    -resultcomment {Broken mixer result} 
    -aliases { raw=chan_01:data }
    -algorithms { 
      x0 = slice(raw,0,100,1);
      f = value(0.125);
      phi = value(0.1);
             
      rx0 = real(x0);
      ix0 = imag(x0);
      variance(rx0);
      intermediate(,,rvarX, {Variance of real input data});
      rms(rx0);
      intermediate(,,rrmsX, {RootMeanSquare of real input data});
      variance(ix0);
      intermediate(,,ivarX, {Variance of imag input data});
      rms(ix0);
      intermediate(,,irmsX, {RootMeanSquare of imag input data});
             
      z0 = mix(phi,f,x0);
             
      x1 = slice(x0,0,50,1);
      x2 = slice(x0,50,50,1);
             
      phi = value(0.1);
             
      z1 = mix(phi,f,x1);
      intermediate(,,z1,{First half mixer});
      z2 = mix(phi,f,x2);
      intermediate(,,z2,{Second half mixer});
             
      zA = slice(z0,0,50,1);
      zB = slice(z0,50,50,1);
             
      rzA = real(zA);
      rzB = real(zB);
      rz1 = real(z1);
      rz2 = real(z2);
      izA = imag(zA);
      izB = imag(zB);
      iz1 = imag(z1);
      iz2 = imag(z2);
             
      rdifA = sub(rzA,rz1);
      intermediate(,,rdifA,{First half real differences});
      min(rdifA);
      intermediate(,,rminA,{Minimum first half real deviation});
      max(rdifA);
      intermediate(,,rmaxA,{Maximum first half real deviation});
             
      rdifB = sub(rzB,rz2);
      intermediate(,,rdifB,{Second half real differences});
      min(rdifB);
      intermediate(,,rminB,{Minimum second half real deviation});
      max(rdifB);
      intermediate(,,rmaxB,{Maximum second half real deviation});
             
      idifA = sub(izA,iz1);
      intermediate(,,idifA,{First half imag differences});
      min(idifA);
      intermediate(,,iminA,{Minimum first half imag deviation});
      max(idifA);
      intermediate(,,imaxA,{Maximum first half imag deviation});
             
      idifB = sub(izB,iz2);
      intermediate(,,idifB,{Second half imag differences});
      min(idifB);
      intermediate(,,iminB,{Minimum second half imag deviation});
      max(idifB);
      intermediate(,,imaxB,{Maximum second half imag deviation});
             
      value(z0);
    } 
}    
\end{verbatim}
\hspace*{\fill} {\bf Pass / Fail}
             
\item Verify that the minimimum and maximum values of the real and 
imaginary parts of the first and second half differences 
are zero to floating point (or double) precision, relative to the 
rms amplitudes of the input data.\\
\hspace*{\fill} {\bf Pass / Fail}
\item Move the output file to {\tt mdc/output/api}.\\
\hspace*{\fill} {\bf Pass / Fail}
             
\end{enumerate}

\noindent
{\bf SUMMARY}
\vspace{1em}

\noindent
{\bf Known faults encountered -- list bug IDs: }\hrulefill\\
\vspace{1em}
\hrule
\vspace{1em}
\noindent
{\bf New faults submitted -- list bug IDs: }\hrulefill \\
\vspace{1em}
\hrule
\vspace{2em}

\noindent
{\bf TEST RESULT } \hfill {\bf Pass / Fail }\\
%% End of test MIXERAPI02
